org.apache.commons.io.input

## Class BrokenInputStream

- java.lang.Object
- - java.io.InputStream
  - - org.apache.commons.io.input.BrokenInputStream

- All Implemented Interfaces:
    Closeable, AutoCloseable

      public class BrokenInputStream
      extends InputStream

  Always throws an `IOException` from all the `InputStream` methods where the exception is declared.

  This class is mostly useful for testing error handling.

  Since:
    2.0

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static BrokenInputStream` | `INSTANCE` The singleton instance.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `BrokenInputStream()` Creates a new stream that always throws an `IOException`.
    `BrokenInputStream(IOException exception)` Creates a new stream that always throws the given exception.
    `BrokenInputStream(Supplier<IOException> exceptionSupplier)` Creates a new stream that always throws an `IOException`.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `available()` Throws the configured exception.
    `void` | `close()` Throws the configured exception.
    `int` | `read()` Throws the configured exception.
    `void` | `reset()` Throws the configured exception.
    `long` | `skip(long n)` Throws the configured exception.

    - ### Methods inherited from class java.io.InputStream

      `mark, markSupported, read, read`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### INSTANCE

          public static final BrokenInputStream INSTANCE

      The singleton instance.
      Since:
        2.12.0

  - ### Constructor Detail

    - #### BrokenInputStream

          public BrokenInputStream()

      Creates a new stream that always throws an `IOException`.

    - #### BrokenInputStream

          public BrokenInputStream(IOException exception)

      Creates a new stream that always throws the given exception.
      Parameters:
        `exception` - the exception to be thrown.

    - #### BrokenInputStream

          public BrokenInputStream(Supplier<IOException> exceptionSupplier)

      Creates a new stream that always throws an `IOException`.
      Parameters:
        `exceptionSupplier` - a supplier for the exception to be thrown.
      Since:
        2.12.0

  - ### Method Detail

    - #### available

          public int available()
                        throws IOException

      Throws the configured exception.
      Overrides:
        `available` in class `InputStream`
      Returns:
        nothing
      Throws:
        `IOException` - always thrown

    - #### close

          public void close()
                     throws IOException

      Throws the configured exception.
      Specified by:
        `close` in interface `Closeable`
      Specified by:
        `close` in interface `AutoCloseable`
      Overrides:
        `close` in class `InputStream`
      Throws:
        `IOException` - always thrown

    - #### read

          public int read()
                   throws IOException

      Throws the configured exception.
      Specified by:
        `read` in class `InputStream`
      Returns:
        nothing
      Throws:
        `IOException` - always thrown

    - #### reset

          public void reset()
                     throws IOException

      Throws the configured exception.
      Overrides:
        `reset` in class `InputStream`
      Throws:
        `IOException` - always thrown

    - #### skip

          public long skip(long n)
                    throws IOException

      Throws the configured exception.
      Overrides:
        `skip` in class `InputStream`
      Parameters:
        `n` - ignored
      Returns:
        nothing
      Throws:
        `IOException` - always thrown

Copyright © 2002–2023 The Apache Software Foundation. All rights reserved.